<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__spi" kind="group">
    <compoundname>group_hal_spi</compoundname>
    <title>SPI (Serial Peripheral Interface)</title>
    <innerclass prot="public" refid="structcyhal__spi__cfg__t">cyhal_spi_cfg_t</innerclass>
    <innergroup refid="group__group__hal__results__spi">SPI HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__spi_1gae8f0cf0233d0225a80815f8282d87b85" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_spi_event_t</name>
        <enumvalue id="group__group__hal__spi_1ggae8f0cf0233d0225a80815f8282d87b85a04910f865434c432b4fb7ba6ee6a4ec5" prot="public">
          <name>CYHAL_SPI_IRQ_DATA_IN_FIFO</name>
          <initializer>= 1 &lt;&lt; 1</initializer>
          <briefdescription>
<para>All transfer data has been moved into data FIFO. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggae8f0cf0233d0225a80815f8282d87b85a3f926937b0199cc8729c443d8e71f91b" prot="public">
          <name>CYHAL_SPI_IRQ_DONE</name>
          <initializer>= 1 &lt;&lt; 2</initializer>
          <briefdescription>
<para>Transfer complete. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggae8f0cf0233d0225a80815f8282d87b85a808355edbb46ce1950705e55f32dc093" prot="public">
          <name>CYHAL_SPI_IRQ_ERROR</name>
          <initializer>= 1 &lt;&lt; 3</initializer>
          <briefdescription>
<para>An error occurred while transferring data. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_spi_event_t: </bold><linebreak />SPI interrupt triggers.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="148" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="141" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="141" />
      </memberdef>
      <memberdef id="group__group__hal__spi_1gabfadf37558e1092ac2fe3a5bd2b912d5" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_spi_ssel_polarity_t</name>
        <enumvalue id="group__group__hal__spi_1ggabfadf37558e1092ac2fe3a5bd2b912d5a3a6c47381becf05d991f9e321ec9fea6" prot="public">
          <name>CYHAL_SPI_SSEL_ACTIVE_LOW</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>SSEL signal is active low. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggabfadf37558e1092ac2fe3a5bd2b912d5ab9e114bf73df1ff5ae5bab536f96c242" prot="public">
          <name>CYHAL_SPI_SSEL_ACTIVE_HIGH</name>
          <initializer>= 1</initializer>
          <briefdescription>
<para>SSEL signal is active high. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_spi_ssel_polarity_t: </bold><linebreak />SPI Slave Select polarity.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="156" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="151" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="151" />
      </memberdef>
      <memberdef id="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_spi_mode_t</name>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a8109c5d0edd4c10a68d82e98bd76de8a" prot="public">
          <name>CYHAL_SPI_MODE_00_MSB</name>
          <initializer>= CYHAL_SPI_MODE(0, 0, 0)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=0, CPHA=0 with MSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a33951c55abcba6e01a67fa8252ec81e1" prot="public">
          <name>CYHAL_SPI_MODE_00_LSB</name>
          <initializer>= CYHAL_SPI_MODE(0, 0, 1)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=0, CPHA=0 with LSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a7ddf4f8ed91e1e46728f74581dec24d9" prot="public">
          <name>CYHAL_SPI_MODE_01_MSB</name>
          <initializer>= CYHAL_SPI_MODE(0, 1, 0)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=0, CPHA=1 with MSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a90c2b77bf8ae38974fcb13a25c1c51a2" prot="public">
          <name>CYHAL_SPI_MODE_01_LSB</name>
          <initializer>= CYHAL_SPI_MODE(0, 1, 1)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=0, CPHA=1 with LSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51ac8c9a9a943e48c87c0fc550c4645c6cd" prot="public">
          <name>CYHAL_SPI_MODE_10_MSB</name>
          <initializer>= CYHAL_SPI_MODE(1, 0, 0)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=1, CPHA=0 with MSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51aae0f7c7fe32a579a9c6226e5472f1ac8" prot="public">
          <name>CYHAL_SPI_MODE_10_LSB</name>
          <initializer>= CYHAL_SPI_MODE(1, 0, 1)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=1, CPHA=0 with LSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a396aa7d1e3a6d7652342a4eb35f91435" prot="public">
          <name>CYHAL_SPI_MODE_11_MSB</name>
          <initializer>= CYHAL_SPI_MODE(1, 1, 0)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=1, CPHA=1 with MSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a7987f1cca1342f6f7721c9118f7a7e26" prot="public">
          <name>CYHAL_SPI_MODE_11_LSB</name>
          <initializer>= CYHAL_SPI_MODE(1, 1, 1)</initializer>
          <briefdescription>
<para>Standard motorola SPI CPOL=1, CPHA=1 with LSB first operation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_spi_mode_t: </bold><linebreak />SPI operating modes.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="191" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="173" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="174" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__spi_1ga49db139205e26d6150dc9a83338d8a1c" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_spi_event_callback_t) (void *callback_arg, cyhal_spi_event_t event)</definition>
        <argsstring>)(void *callback_arg, cyhal_spi_event_t event)</argsstring>
        <name>cyhal_spi_event_callback_t</name>
        <briefdescription>
<para>Handler for SPI interrupts. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="159" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="159" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_init</definition>
        <argsstring>(cyhal_spi_t *obj, cyhal_gpio_t mosi, cyhal_gpio_t miso, cyhal_gpio_t sclk, cyhal_gpio_t ssel, const cyhal_clock_t *clk, uint8_t bits, cyhal_spi_mode_t mode, bool is_slave)</argsstring>
        <name>cyhal_spi_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>mosi</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>miso</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>sclk</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>ssel</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>bits</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref></type>
          <declname>mode</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>is_slave</declname>
        </param>
        <briefdescription>
<para>Initialize the SPI peripheral. </para>        </briefdescription>
        <detaileddescription>
<para>Configures the pins used by SPI, sets a default format and frequency, and enables the peripheral <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a SPI object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mosi</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for MOSI </para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;At least MOSI or MISO pin should be non-NC &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">miso</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for MISO </para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;At least MOSI or MISO pin should be non-NC &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">sclk</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for SCLK </para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This pin cannot be NC &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">ssel</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for SSEL </para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Provided pin will be configured for &lt;a href="group__group__hal__spi.html#group__group__hal__spi_1ggabfadf37558e1092ac2fe3a5bd2b912d5a3a6c47381becf05d991f9e321ec9fea6"&gt;CYHAL_SPI_SSEL_ACTIVE_LOW&lt;/a&gt; polarity and set as active. This can be changed (as well as additional ssel pins can be added) by &lt;a href="group__group__hal__spi.html#group__group__hal__spi_1gaf933d1bcc357b515bd3cc0ad4518c764"&gt;cyhal_spi_slave_select_config&lt;/a&gt; and &lt;a href="group__group__hal__spi.html#group__group__hal__spi_1gab545fa07b788c83398c0265b2e9220c9"&gt;cyhal_spi_select_active_ssel&lt;/a&gt; functions. This pin can be NC. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">clk</parametername>
</parameternamelist>
<parameterdescription>
<para>The clock to use can be shared, if not provided a new clock will be allocated </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">bits</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bits per frame </para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;bits should be 8 or 16 &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">mode</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI mode (clock polarity, phase, and shift direction) </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">is_slave</parametername>
</parameternamelist>
<parameterdescription>
<para>false for master mode or true for slave mode operation </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="531" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="330" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="223" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1gab2bbcc53213e50e43a9bd223573b7870" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_spi_free</definition>
        <argsstring>(cyhal_spi_t *obj)</argsstring>
        <name>cyhal_spi_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Release a SPI object. </para>        </briefdescription>
        <detaileddescription>
<para>Return the peripheral, pins and clock owned by the SPI object to their reset state <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object to deinitialize </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="565" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="533" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="231" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_set_frequency</definition>
        <argsstring>(cyhal_spi_t *obj, uint32_t hz)</argsstring>
        <name>cyhal_spi_set_frequency</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>hz</declname>
        </param>
        <briefdescription>
<para>Set the SPI baud rate. </para>        </briefdescription>
        <detaileddescription>
<para>Actual frequency may differ from the desired frequency due to available dividers and bus clock Configures the SPI peripheral's baud rate <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object to configure </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">hz</parametername>
</parameternamelist>
<parameterdescription>
<para>The baud rate in Hz </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set_frequency request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="616" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="583" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="241" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1gaf933d1bcc357b515bd3cc0ad4518c764" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_slave_select_config</definition>
        <argsstring>(cyhal_spi_t *obj, cyhal_gpio_t ssel, cyhal_spi_ssel_polarity_t polarity)</argsstring>
        <name>cyhal_spi_slave_select_config</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>ssel</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__spi_1gabfadf37558e1092ac2fe3a5bd2b912d5">cyhal_spi_ssel_polarity_t</ref></type>
          <declname>polarity</declname>
        </param>
        <briefdescription>
<para>Configures provided ssel pin to work as SPI slave select with specified polarity. </para>        </briefdescription>
        <detaileddescription>
<para>Multiple pins can be configured as SPI slave select pins. Please refer to device datasheet for details. Switching between configured slave select pins is done by <ref kindref="member" refid="group__group__hal__spi_1gab545fa07b788c83398c0265b2e9220c9">cyhal_spi_select_active_ssel</ref> function. Unless modified with this function, the SSEL pin provided as part of <ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init</ref> is the default. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object to add slave select for </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">ssel</parametername>
</parameternamelist>
<parameterdescription>
<para>Slave select pin to be added </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">polarity</parametername>
</parameternamelist>
<parameterdescription>
<para>Polarity of slave select </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of ssel pin configuration </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="700" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="642" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="253" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1gab545fa07b788c83398c0265b2e9220c9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_select_active_ssel</definition>
        <argsstring>(cyhal_spi_t *obj, cyhal_gpio_t ssel)</argsstring>
        <name>cyhal_spi_select_active_ssel</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>ssel</declname>
        </param>
        <briefdescription>
<para>Selects an active slave select line from one of available. </para>        </briefdescription>
        <detaileddescription>
<para>This function is applicable for the master and slave. SSEL pin should be configured by <ref kindref="member" refid="group__group__hal__spi_1gaf933d1bcc357b515bd3cc0ad4518c764">cyhal_spi_slave_select_config</ref> or <ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init</ref> functions prior to selecting it as active. The active slave select line will automatically be toggled as part of any transfer. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object for switching </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">ssel</parametername>
</parameternamelist>
<parameterdescription>
<para>Slave select pin to be set as active </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if slave select was switched successfully, otherwise - CYHAL_SPI_RSLT_ERR_CANNOT_SWITCH_SSEL </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="635" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="618" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="264" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1gad9e6f6399f3096426b718d58e813b0d1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_recv</definition>
        <argsstring>(cyhal_spi_t *obj, uint32_t *value)</argsstring>
        <name>cyhal_spi_recv</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>value</declname>
        </param>
        <briefdescription>
<para>Synchronously get a received value out of the SPI receive buffer. </para>        </briefdescription>
        <detaileddescription>
<para>In Master mode - transmits fill-in value and read the data from RxFifo In Slave mode - Blocks until a value is available</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI peripheral to read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">value</parametername>
</parameternamelist>
<parameterdescription>
<para>The value received </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read request </para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ul&gt;&lt;li&gt;&lt;p&gt;In Master mode, MISO pin required to be non-NC for this API to operate&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;In Slave mode, MOSI pin required to be non-NC for this API to operate &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="748" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="702" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="278" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga24b88b94f4869a34a98a54fc0edf9e53" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_send</definition>
        <argsstring>(cyhal_spi_t *obj, uint32_t value)</argsstring>
        <name>cyhal_spi_send</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>value</declname>
        </param>
        <briefdescription>
<para>Synchronously send a byte out. </para>        </briefdescription>
        <detaileddescription>
<para>In Master mode transmits value to slave and read/drop a value from the RxFifo. In Slave mode writes a value to TxFifo</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI peripheral to use for sending </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">value</parametername>
</parameternamelist>
<parameterdescription>
<para>The value to send </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the write request </para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ul&gt;&lt;li&gt;&lt;p&gt;In Master mode, MOSI pin required to be non-NC for this API to operate&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;In Slave mode, MISO pin required to be non-NC for this API to operate &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="794" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="750" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="292" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1gad21547fa4048c45f15308c0b1ff62c1f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_transfer</definition>
        <argsstring>(cyhal_spi_t *obj, const uint8_t *tx, size_t tx_length, uint8_t *rx, size_t rx_length, uint8_t write_fill)</argsstring>
        <name>cyhal_spi_transfer</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>tx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>tx_length</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>rx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>rx_length</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>write_fill</declname>
        </param>
        <briefdescription>
<para>Synchronously Write a block out and receive a value. </para>        </briefdescription>
        <detaileddescription>
<para>The total number of bytes sent and received will be the maximum of tx_length and rx_length. The bytes written will be padded (at the end) with the value given by write_fill.</para><para>This function will block for the duration of the transfer. <ref kindref="member" refid="group__group__hal__spi_1ga3cbcb44263ba6af2668f8847b8c90210">cyhal_spi_transfer_async</ref> can be used for non-blocking transfers.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI peripheral to use for sending </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the byte-array of data to write to the device </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">tx_length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes to write, updated with the number actually written </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">rx</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the byte-array of data to read from the device </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">rx_length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes to read, updated with the number actually read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">write_fill</parametername>
</parameternamelist>
<parameterdescription>
<para>Default data transmitted while performing a read </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the transfer request </para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Both MOSI and MISO pins required to be non-NC for this API to operate &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="812" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="796" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="312" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga3cbcb44263ba6af2668f8847b8c90210" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_transfer_async</definition>
        <argsstring>(cyhal_spi_t *obj, const uint8_t *tx, size_t tx_length, uint8_t *rx, size_t rx_length)</argsstring>
        <name>cyhal_spi_transfer_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>tx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>tx_length</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>rx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>rx_length</declname>
        </param>
        <briefdescription>
<para>Start an asynchronous SPI transfer. </para>        </briefdescription>
        <detaileddescription>
<para>This will transfer rx_length bytes into the buffer pointed to by rx, while simultaneously transfering tx_length bytes of data from the buffer pointed to by tx, both in the background. When the transfer is complete, the <ref kindref="member" refid="group__group__hal__spi_1ggae8f0cf0233d0225a80815f8282d87b85a3f926937b0199cc8729c443d8e71f91b">CYHAL_SPI_IRQ_DONE</ref> event will be raised. See <ref kindref="member" refid="group__group__hal__spi_1ga5efa8d542f1ab5307d7896a249581a6a">cyhal_spi_register_callback</ref> and <ref kindref="member" refid="group__group__hal__spi_1ga6d53ecb445603a2470ec1fd7e456bba3">cyhal_spi_enable_event</ref>. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;For blocking transfers cyhal_spi_transfer can be used.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object that holds the transfer information </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx</parametername>
</parameternamelist>
<parameterdescription>
<para>The transmit buffer </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">tx_length</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bytes to transmit </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">rx</parametername>
</parameternamelist>
<parameterdescription>
<para>The receive buffer </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">rx_length</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bytes to receive </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the transfer_async request </para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Both MOSI and MISO pins required to be non-NC for this API to operate &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="890" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="814" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="330" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga94cd6755137c445776a75f29af355cab" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_spi_is_busy</definition>
        <argsstring>(cyhal_spi_t *obj)</argsstring>
        <name>cyhal_spi_is_busy</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified SPI peripheral is in use. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Indication of whether the SPI is still transmitting </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="895" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="892" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="337" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga2d4d48b53480a80e11d6ae5ebd01c0c2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_spi_abort_async</definition>
        <argsstring>(cyhal_spi_t *obj)</argsstring>
        <name>cyhal_spi_abort_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Abort an SPI transfer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI peripheral to stop </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the abort_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="907" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="897" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="344" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga5efa8d542f1ab5307d7896a249581a6a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_spi_register_callback</definition>
        <argsstring>(cyhal_spi_t *obj, cyhal_spi_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_spi_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__spi_1ga49db139205e26d6150dc9a83338d8a1c">cyhal_spi_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register a SPI callback handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__spi_1ga6d53ecb445603a2470ec1fd7e456bba3">cyhal_spi_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when the interrupt fires </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="918" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="909" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="354" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__spi_1ga6d53ecb445603a2470ec1fd7e456bba3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_spi_enable_event</definition>
        <argsstring>(cyhal_spi_t *obj, cyhal_spi_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_spi_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__spi_1gae8f0cf0233d0225a80815f8282d87b85">cyhal_spi_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure SPI interrupt. </para>        </briefdescription>
        <detaileddescription>
<para>This function is used for word-approach</para><para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__spi_1ga5efa8d542f1ab5307d7896a249581a6a">cyhal_spi_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The SPI event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on interrupts, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="933" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_spi.c" bodystart="920" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="365" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__spi_1ga778a64304a68622c7a3b0f2551d82ea9" kind="define" prot="public" static="no">
        <name>cyhal_spi_frequency</name>
        <initializer><ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency</ref></initializer>
        <briefdescription>
<para>Compatibility define for cyhal_spi_set_frequency. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="138" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="138" />
      </memberdef>
      <memberdef id="group__group__hal__spi_1ga71078e4a04040e81f171c21bae4269b9" kind="define" prot="public" static="no">
        <name>CYHAL_SPI_MODE_FLAG_LSB</name>
        <initializer>(0x01u)</initializer>
        <briefdescription>
<para>Flag for SPI <ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref> values indicating that the LSB is sent first. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="162" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="162" />
      </memberdef>
      <memberdef id="group__group__hal__spi_1gaad78a88937b2e405bd296dc88d2720d8" kind="define" prot="public" static="no">
        <name>CYHAL_SPI_MODE_FLAG_CPHA</name>
        <initializer>(0x02u)</initializer>
        <briefdescription>
<para>Flag for SPI <ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref> values indicating that the CPHA=1. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="164" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="164" />
      </memberdef>
      <memberdef id="group__group__hal__spi_1ga028740fed4f8c4dac07d1b33d68adf94" kind="define" prot="public" static="no">
        <name>CYHAL_SPI_MODE_FLAG_CPOL</name>
        <initializer>(0x04u)</initializer>
        <briefdescription>
<para>Flag for SPI <ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref> values indicating that the CPOL=1. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="166" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="166" />
      </memberdef>
      <memberdef id="group__group__hal__spi_1ga740c6c1f20565a1ae924ec22a9a71cd0" kind="define" prot="public" static="no">
        <name>CYHAL_SPI_MODE</name>
        <param><defname>cpol</defname></param>
        <param><defname>cpha</defname></param>
        <param><defname>lsb</defname></param>
        <initializer>(((cpol &gt; 0) ? <ref kindref="member" refid="group__group__hal__spi_1ga028740fed4f8c4dac07d1b33d68adf94">CYHAL_SPI_MODE_FLAG_CPOL</ref> : 0) | \
                                             ((cpha &gt; 0) ? <ref kindref="member" refid="group__group__hal__spi_1gaad78a88937b2e405bd296dc88d2720d8">CYHAL_SPI_MODE_FLAG_CPHA</ref> : 0) | \
                                             (( lsb &gt; 0) ? <ref kindref="member" refid="group__group__hal__spi_1ga71078e4a04040e81f171c21bae4269b9">CYHAL_SPI_MODE_FLAG_LSB</ref>  : 0))</initializer>
        <briefdescription>
<para>Creates a <ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref> value given the cpol, cpha, lsb values. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" bodystart="168" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_spi.h" line="168" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>High level interface for interacting with the Serial Peripheral Interface (SPI). </para>    </briefdescription>
    <detaileddescription>
<para>The SPI protocol is a synchronous serial interface protocol. Devices operate in either master or slave mode. The master initiates the data transfer.</para><para>Motorola SPI modes 0, 1, 2, and 3 are supported, with either MSB or LSB first. The operating mode and data frame size can be configured via <ref kindref="compound" refid="structcyhal__spi__cfg__t">cyhal_spi_cfg_t</ref>.</para>
<para><heading level="1">Features</heading></para>
<para><itemizedlist>
<listitem><para>Supports master and slave functionality.</para></listitem><listitem><para>Supports Motorola modes - 0, 1, 2 and 3 - <ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref></para></listitem><listitem><para>MSb or LSb first shift direction - <ref kindref="member" refid="group__group__hal__spi_1gaf56d895e50b0cf0e858a1ff221c58d51">cyhal_spi_mode_t</ref></para></listitem><listitem><para>Master supports up to four slave select lines</para></listitem><listitem><para>Supports data frame size of 8 or 16 bits</para></listitem><listitem><para>Configurable interrupt and callback assignment on SPI events: Data transfer to FIFO complete, Transfer complete and Transmission error - <ref kindref="member" refid="group__group__hal__spi_1gae8f0cf0233d0225a80815f8282d87b85">cyhal_spi_event_t</ref></para></listitem><listitem><para>Supports changing baud rate of the transaction in run time.</para></listitem><listitem><para>Provides functions to send/receive a single byte or block of data.</para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para>Initialise a SPI master or slave interface using <ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init()</ref> and provide the SPI pins (<bold>mosi</bold>, <bold>miso</bold>, <bold>sclk</bold>, <bold>ssel</bold>), number of bits per frame (<bold>data_bits</bold>) and SPI Motorola <bold>mode</bold>. The data rate can be set using <ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency()</ref>. <linebreak />
 See <ref kindref="member" refid="group__group__hal__spi_1section_spi_snippets">Code snippets</ref> for code snippets to send or receive the data.</para>

<para><heading level="1">Code snippets</heading></para>

<para><bold>Snippet 1: SPI Master - Single byte transfer operation (Read and Write)</bold></para>
<para>The following code snippet initializes an SPI Master interface using the <ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init()</ref>. The data rate of transfer is set using <ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency()</ref>. The code snippet shows how to transfer a single byte of data using <ref kindref="member" refid="group__group__hal__spi_1ga24b88b94f4869a34a98a54fc0edf9e53">cyhal_spi_send()</ref> and <ref kindref="member" refid="group__group__hal__spi_1gad9e6f6399f3096426b718d58e813b0d1">cyhal_spi_recv()</ref>. <programlisting filename="spi.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref><sp />mSPI;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />spi_master_frequency<sp />=<sp />1000000;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />transmit_data<sp />=<sp />0x01;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />receive_data;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuring<sp />the<sp /><sp />SPI<sp />master:<sp /><sp />Specify<sp />the<sp />SPI<sp />interface<sp />pins,<sp />frame<sp />size,<sp />SPI<sp />Motorola<sp />mode<sp />and<sp />master<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init</ref>(&amp;mSPI,<sp />CYBSP_SPI_MOSI,<sp />CYBSP_SPI_MISO,<sp />CYBSP_SPI_CLK,<sp />CYBSP_SPI_CS,<sp />NULL,<sp />8,<sp /><ref kindref="member" refid="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a8109c5d0edd4c10a68d82e98bd76de8a">CYHAL_SPI_MODE_00_MSB</ref>,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />data<sp />rate<sp />to<sp />1<sp />Mbps<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency</ref>(&amp;mSPI,<sp />spi_master_frequency);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Transfer<sp />one<sp />byte<sp />of<sp />data<sp />to<sp />the<sp />slave.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__spi_1ga24b88b94f4869a34a98a54fc0edf9e53">cyhal_spi_send</ref>(&amp;mSPI,<sp />transmit_data))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Receives<sp />one<sp />byte<sp />of<sp />data<sp />from<sp />the<sp />slave<sp />by<sp />transmiting<sp />a<sp />dummy<sp />byte<sp />0xFF.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__spi_1gad9e6f6399f3096426b718d58e813b0d1">cyhal_spi_recv</ref>(&amp;mSPI,<sp />&amp;receive_data))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Transfer<sp />Complete<sp />and<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: SPI Slave - Single byte transfer operation (Read and Write)</bold></para>
<para>The following code snippet initializes an SPI Slave interface using the <ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init()</ref>. The data rate of transfer is set using <ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency</ref>. The code snippet shows how to transfer a single byte of data using <ref kindref="member" refid="group__group__hal__spi_1ga24b88b94f4869a34a98a54fc0edf9e53">cyhal_spi_send()</ref> and <ref kindref="member" refid="group__group__hal__spi_1gad9e6f6399f3096426b718d58e813b0d1">cyhal_spi_recv</ref>. <programlisting filename="spi.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref><sp />sSPI;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />spi_slave_frequency<sp />=<sp />1000000;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />transmit_data<sp />=<sp />1;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />receive_data;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuring<sp />the<sp /><sp />SPI<sp />slave:<sp /><sp />Specify<sp />the<sp />SPI<sp />interface<sp />pins,<sp />frame<sp />size,<sp />SPI<sp />Motorola<sp />mode<sp />and<sp />slave<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init</ref>(&amp;sSPI,<sp />CYBSP_SPI_MOSI,<sp />CYBSP_SPI_MISO,<sp />CYBSP_SPI_CLK,<sp />CYBSP_SPI_CS,<sp />NULL,<sp />8,<sp /><ref kindref="member" refid="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a8109c5d0edd4c10a68d82e98bd76de8a">CYHAL_SPI_MODE_00_MSB</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />data<sp />rate<sp />to<sp />1<sp />Mbps<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency</ref>(&amp;sSPI,<sp />spi_slave_frequency);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Place<sp />a<sp />byte<sp />in<sp />the<sp />TX<sp />FIFO<sp />to<sp />be<sp />read<sp />by<sp />the<sp />master<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__spi_1ga24b88b94f4869a34a98a54fc0edf9e53">cyhal_spi_send</ref>(&amp;sSPI,<sp />transmit_data))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />a<sp />received<sp />value<sp />out<sp />of<sp />the<sp />SPI<sp />receive<sp />buffer.<sp />This<sp />API<sp />Blocks<sp />until<sp />a<sp />value<sp />is<sp />available<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__spi_1gad9e6f6399f3096426b718d58e813b0d1">cyhal_spi_recv</ref>(&amp;sSPI,<sp />&amp;receive_data))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Transfer<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 3: SPI Block Data transfer</bold></para>
<para>The following snippet sends and receives an array of data in a single SPI transaction using <ref kindref="member" refid="group__group__hal__spi_1gad21547fa4048c45f15308c0b1ff62c1f">cyhal_spi_transfer()</ref>. The example uses SPI master to transmit 5 bytes of data and receive 5 bytes of data in a single transaction. <programlisting filename="spi.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref><sp />mSPI;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />spi_frequency<sp />=<sp />1000000;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />transmit_data[5]<sp />=<sp />{0x1,<sp />0x2,<sp />0x3,<sp />0x4,<sp />0x5};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />receive_data[5];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />BSP-1637<sp />workaround<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memset(&amp;mSPI,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(mSPI));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuring<sp />the<sp /><sp />SPI<sp />interface:<sp /><sp />Specify<sp />the<sp />SPI<sp />interface<sp />pins,<sp />frame<sp />size,<sp />SPI<sp />Motorola<sp />mode<sp />and<sp />master/slave<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init</ref>(&amp;mSPI,<sp />CYBSP_SPI_MOSI,<sp />CYBSP_SPI_MISO,<sp />CYBSP_SPI_CLK,<sp />CYBSP_SPI_CS,<sp />NULL,<sp />8,<sp /><ref kindref="member" refid="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a8109c5d0edd4c10a68d82e98bd76de8a">CYHAL_SPI_MODE_00_MSB</ref>,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />data<sp />rate<sp />to<sp />1<sp />Mbps<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency</ref>(&amp;mSPI,<sp />spi_frequency);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Master:<sp />Starts<sp />a<sp />data<sp />transfer.<sp />Slave:<sp />Prepares<sp />the<sp />slave<sp />for<sp />data<sp />transfer.<sp />It<sp />is<sp />a<sp />blocking<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp /><sp /><ref kindref="member" refid="group__group__hal__spi_1gad21547fa4048c45f15308c0b1ff62c1f">cyhal_spi_transfer</ref>(&amp;mSPI,<sp />transmit_data,<sp />5u,<sp />receive_data,<sp />5u,<sp />0xFF))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Transfer<sp />Complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 4: Interrupts on SPI events</bold></para>
<para>SPI interrupt events ( <ref kindref="member" refid="group__group__hal__spi_1gae8f0cf0233d0225a80815f8282d87b85">cyhal_spi_event_t</ref>) can be mapped to an interrupt and assigned to a callback function. The callback function needs to be first registered and then the event needs to be enabled. The following snippet initialises a SPI master to perform a block transfer using <ref kindref="member" refid="group__group__hal__spi_1ga3cbcb44263ba6af2668f8847b8c90210">cyhal_spi_transfer_async()</ref>. This is a non-blocking function. A callback function is registered using <ref kindref="member" refid="group__group__hal__spi_1ga5efa8d542f1ab5307d7896a249581a6a">cyhal_spi_register_callback</ref> to notify whenever the SPI transfer is complete. <programlisting filename="spi.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />spi_interrupt_callback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*arg,<sp /><ref kindref="member" refid="group__group__hal__spi_1gae8f0cf0233d0225a80815f8282d87b85">cyhal_spi_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__spi_1ggae8f0cf0233d0225a80815f8282d87b85a3f926937b0199cc8729c443d8e71f91b">CYHAL_SPI_IRQ_DONE</ref><sp />)<sp />!=<sp />0u)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Transmission<sp />is<sp />complete.<sp />Handle<sp />Event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_interrupt_callback_events(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__spi__t">cyhal_spi_t</ref><sp />mSPI;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />spi_frequency<sp />=<sp />1000000;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />rx_transfer_count<sp />=<sp />5,<sp />tx_transfer_count<sp />=<sp />5;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />receive_data[5];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />transmit_data[5]<sp />=<sp />{0x1,<sp />0x2,<sp />0x3,<sp />0x4,<sp />0x5};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuring<sp />the<sp /><sp />SPI<sp />interface:<sp /><sp />Specify<sp />the<sp />SPI<sp />interface<sp />pins,<sp />frame<sp />size,<sp />SPI<sp />Motorola<sp />mode<sp />and<sp />master/slave<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga20c9cdb5b051ff8b68cf313fc19b550d">cyhal_spi_init</ref>(&amp;mSPI,<sp />CYBSP_SPI_MOSI,<sp />CYBSP_SPI_MISO,<sp />CYBSP_SPI_CLK,<sp />CYBSP_SPI_CS,<sp />NULL,<sp />8,<sp /><ref kindref="member" refid="group__group__hal__spi_1ggaf56d895e50b0cf0e858a1ff221c58d51a8109c5d0edd4c10a68d82e98bd76de8a">CYHAL_SPI_MODE_00_MSB</ref>,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />data<sp />rate<sp />to<sp />1<sp />Mbps<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__spi_1ga536ac25a0556330a35651e32b5c180cb">cyhal_spi_set_frequency</ref>(&amp;mSPI,<sp />spi_frequency);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />function<sp />to<sp />be<sp />called<sp />when<sp />the<sp />interrupt<sp />fires<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__spi_1ga5efa8d542f1ab5307d7896a249581a6a">cyhal_spi_register_callback</ref>(&amp;mSPI,<sp />(<ref kindref="member" refid="group__group__hal__spi_1ga49db139205e26d6150dc9a83338d8a1c">cyhal_spi_event_callback_t</ref>)<sp />spi_interrupt_callback,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />events<sp />that<sp />will<sp />trigger<sp />the<sp />call<sp />back<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__spi_1ga6d53ecb445603a2470ec1fd7e456bba3">cyhal_spi_enable_event</ref>(&amp;mSPI,<sp /><ref kindref="member" refid="group__group__hal__spi_1ggae8f0cf0233d0225a80815f8282d87b85a3f926937b0199cc8729c443d8e71f91b">CYHAL_SPI_IRQ_DONE</ref>,<sp />3,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Master:<sp />Initiates<sp />a<sp />data<sp />transfer.<sp />Slave:<sp />Prepares<sp />the<sp />slave<sp />for<sp />data<sp />transfer.<sp />It<sp />is<sp />a<sp />non-blocking<sp />function<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__spi_1ga3cbcb44263ba6af2668f8847b8c90210">cyhal_spi_transfer_async</ref>(&amp;mSPI,<sp />transmit_data,<sp />rx_transfer_count,<sp />receive_data,<sp />tx_transfer_count))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SPI<sp />Master:<sp />Transfer<sp />started.<sp />SPI<sp />Slave:<sp />Prepares<sp />for<sp />data<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>


<para><heading level="1">More Information</heading></para>
<para><itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-spi-master">mtb-example-psoc6-spi-master</ulink>: This example project demonstrates use of SPI (HAL) resource in PSoC® 6 MCU in Master mode to write data to an SPI slave. </para></listitem></itemizedlist>
</para>
    </detaileddescription>
  </compounddef>
</doxygen>